unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, Grids, DBGrids, DB, ADODB, Buttons, DBCommon;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    CheckListBox1: TCheckListBox;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    DataSource1: TDataSource;
    Memo2: TMemo;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ADOQuery1AfterOpen(DataSet: TDataSet);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure ADOQuery1AfterClose(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ADOQuery1.Close;
  ADOQuery1.SQL.Clear;
  if Memo1.Lines.Text <> '' then
    Try
      ADOQuery1.SQL.Add(Memo1.Lines.Text);
      ADOQuery1.Open;
    Except
      ShowMessage('SQLyk~!');
    end
  else
    begin
      Memo1.SetFocus;
      ShowMessage('LSQLd߻yk!')
    end;
end;

procedure TForm1.ADOQuery1AfterOpen(DataSet: TDataSet);
var
  I,J : Integer;
begin
  CheckListBox1.Items.Clear;
  For I:=0 To ADOQuery1.FieldCount-1 do
  CheckListBox1.Items.Add(ADOQuery1.Fields[I].FieldName);
  For J:=0 To CheckListBox1.Items.Count-1 do
  CheckListBox1.Checked[J] := True;
  Label4.Caption := GetTableNameFromSQL(ADOQuery1.SQL.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
  I : Integer;
begin
  DBGrid1.Columns.Clear;
  For I:=0 To CheckListBox1.Items.Count-1 do
    begin
      DBGrid1.Columns.Add;
      DBGrid1.Columns[I].FieldName := CheckListBox1.Items.Strings[I];
      if CheckListBox1.Checked[I] then
        DBGrid1.Columns[I].Visible := True
      else
        DBGrid1.Columns[I].Visible := False;
    end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
Var
  I : Integer;
begin
    CheckListBox1.Items.Exchange(CheckListBox1.ItemIndex,0);
    DBGrid1.Columns.Clear;
    For I:=0 To CheckListBox1.Items.Count-1 do
      begin
        DBGrid1.Columns.Add;
        DBGrid1.Columns[I].FieldName := CheckListBox1.Items.Strings[I];
        if CheckListBox1.Checked[I] then
          DBGrid1.Columns[I].Visible := True
        else
          DBGrid1.Columns[I].Visible := False;
      end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Memo1.SetFocus;
  Memo1.Lines.Text := 'Select * From q';
  Memo1.SelectAll;
end;

procedure TForm1.CheckListBox1Click(Sender: TObject);
begin
  BitBtn1.Enabled := True;
end;

procedure TForm1.ADOQuery1AfterClose(DataSet: TDataSet);
begin
  Label4.Caption := '';
  CheckListBox1.Items.Clear;
end;

end.
